

import jas.space.ObjGrid;

import java.util.Set;

public class Worker extends DomainPlayer {

	private double currentSubsitenceLevel;
	private double consumptionPerTurn;
	private double incrementWhenWorking; 
	private double minSubsitenceLevel;
	
	public Worker(ObjGrid space, Set[][] domain, 
			double currentSubsitenceLevel, double consumptionPerTurn,
			double incrementWhenWorking, double minSubsitenceLevel) {
		super(space, domain);
		setAtRandom();
		
		this.currentSubsitenceLevel = currentSubsitenceLevel;
		this.consumptionPerTurn = consumptionPerTurn;
		this.incrementWhenWorking = incrementWhenWorking;
		this.minSubsitenceLevel = minSubsitenceLevel;
	}

	public Worker(ObjGrid space, Set[][] domain, 
			double currentSubsitenceLevel, double consumptionPerTurn,
			double incrementWhenWorking, double minSubsitenceLevel, Worker nearTo) {
		super(space, domain);
		
		setNear(nearTo);
		
		this.currentSubsitenceLevel = currentSubsitenceLevel;
		this.consumptionPerTurn = consumptionPerTurn;
		this.incrementWhenWorking = incrementWhenWorking;
		this.minSubsitenceLevel = minSubsitenceLevel;
	}
	
	public double updateConsumption() // compute consumption and returns level
	{
		currentSubsitenceLevel -= consumptionPerTurn;
		if (currentSubsitenceLevel < minSubsitenceLevel)
			delete();
		return currentSubsitenceLevel;
	}
	
	public void work() {
		currentSubsitenceLevel += incrementWhenWorking;
	}
}
